<?php

	require_once( $CONTENTIGO_LOCATION . '/contentigo.config.php');

	//standard environments
	/*
	define('DEVELOPMENT', 1);
	define('STAGING', 2);
	define('PRODUCTION', 3);*/


	class Contentigo {

		function Contentigo() {
		}
		
		function go( $site) {

			global $CONTENTIGO_LOCATION;
			global $SITE_LOCATION;
			global $URL_RESOURCE_MAP;

			$originalPath = $_REQUEST['path'];
			$fullPath = rtrim( $originalPath, '/');
			$pathParts = explode( '/', $fullPath);
	
			//======= INIT SMARTY TEMPLATES ======
			require_once( $CONTENTIGO_LOCATION . '/lib/Smarty-2.6.26/libs/Smarty.class.php');
			$smarty = new Smarty();
			
			//assign templates_c directory to smarty
			$compiledTemplateDir = $SITE_LOCATION . '/_cache/templates_c';
			if( !file_exists( $compiledTemplateDir) ) {
				$createCompiledTemplateDirSuccess = mkdir( $compiledTemplateDir, 0777, true);
				if( $createCompiledTemplateDirSuccess) {
					//echo 'created susces';
				} else {
					//echo 'noooo';
				}
			}
			$smarty->compile_dir = $compiledTemplateDir;


			//===== Environment variables to smarty:
			$siteData['root'] = $site['ROOT'];
//			$siteData['name'] = $site['NAME'];
		  	$smarty->assign('site', $siteData);


	
			//check to see if url is defined in resources:
			if( isset( $URL_RESOURCE_MAP[ $pathParts[0] ]) ) {
				//yes, our url is a resource:
				//$resourceTypeDef = $URL_RESOURCE_MAP[ $pathParts[0] ];
				
				//*** WHEN CACHING CSS/JAVASCRIPT/ becareful to cache with local:
				//*** "/cached/homepage_en.css" or "/cached/homepage_en-gb-london.css"
				
				//HANDLE CSS:
				if( CSS === $pathParts[0]) {
					$cssFilenameParts = explode('.', $pathParts[1], 2);
					//for css we want all the locale files:
					$cssDataFiles = getAllLocaleFileNames( $SITE_LOCATION . '/resources/' . CSS . '/' . $cssFilenameParts[0], $site['DEFAULT_LOCALE'], '.' . $cssFilenameParts[1] . '.tpl');
					foreach( $cssDataFiles as $filePath) {
			 			header('Content-type: text/css');
 						$smarty->display( $filePath);
			 			//readfile( $filePath);
					}
					exit;
				}
				
				if( JAVASCRIPT === $pathParts[0]) {
					$javascriptFilenameParts = explode('.', $pathParts[1], 2);
					//for javascript we want all the locale files:
					$javascriptDataFiles = getAllLocaleFileNames( $SITE_LOCATION . '/resources/' . JAVASCRIPT . '/' . $javascriptFilenameParts[0], $site['DEFAULT_LOCALE'], '.' . $javascriptFilenameParts[1]);
					foreach( $javascriptDataFiles as $filePath) {
			 			header('Content-type: application/javascript');
			 			readfile( $filePath);
					}
					exit;
				}

				if( IMAGES === $pathParts[0]) {
					$imageFilenameParts = explode('.', $pathParts[1], 2);
					$imageFileName = getLocaleFileName( $SITE_LOCATION . '/resources/' . IMAGES . '/' . $imageFilenameParts[0], $site['DEFAULT_LOCALE'], '.' . $imageFilenameParts[1]);
		 			header('Content-type: image/png');
		 			readfile( $imageFileName);
					exit;
				}

				if( FONTS === $pathParts[0]) {
					$fontFilenameParts = explode('.', $pathParts[1], 2);
					//for css we want all the locale files:
					$fontFileName = getLocaleFileName( $SITE_LOCATION . '/resources/' . FONTS . '/' . $fontFilenameParts[0], $site['DEFAULT_LOCALE'], '.' . $fontFilenameParts[1]);
		 			//header('Content-type: image/png');	//??????
		 			readfile( $fontFileName);
					exit;
				}
				
			}
			
			
			$cdef = $site['URL_CONTENT_MAP'][ $fullPath];

			if( !isset( $cdef) ) {
				//URL not found! return a 404 page:
				//header("HTTP/1.0 404 Not Found");
				//header($_SERVER["SERVER_PROTOCOL"]." 404 Not Found");
				//header("Status: 404 Not Found");
				echo '<h1>Document not found</h1>';
				exit;
			}


			if( isset( $cdef['actions']) && !empty( $cdef['actions']) ) {
				//handle actions array ...
				
			}


			//====== LOAD VIEW DATA ======
			$viewData = array();

			//load site data:
			$siteDataFile = getLocaleFileName( $SITE_LOCATION . '/content/site_content/site', $site['DEFAULT_LOCALE'], '.txt'); 
		 	if( !file_exists( $siteDataFile) ) {
				//site data file does not exist
		 	} else {
		 		$siteJSONData = file_get_contents( $siteDataFile);
		 		$viewData = json_decode( cleanJSONString( $siteJSONData), true);
		 	}


			//load template data:
			$templateName = $site['DEFAULT_TEMPLATE'];
			if( isset( $cdef['template']) && !empty( $cdef['template']) ) {
				$templateName = $cdef['template'];
			}
			$templateDataFile = getLocaleFileName( $SITE_LOCATION . '/content/template_content/' . $templateName . '/' . $templateName, $site['DEFAULT_LOCALE'], '.txt');
		 	if( !file_exists( $templateDataFile) ) {
				//template data file does not exist
		 	} else {
		 		$templateJSONData = file_get_contents( $templateDataFile);
		 		$templateViewData = json_decode( cleanJSONString( $templateJSONData), true);
		 		$viewData = array_merge( $viewData, $templateViewData);	//site values will be overwritten by template values - cascade
		 	}


			//load block data: should block data override site/template data - not sure...
			if( isset( $site['GLOBAL_BLOCKS'] ) && !empty( $site['GLOBAL_BLOCKS'] ) ) {
				foreach( $site['GLOBAL_BLOCKS'] as $blockName) {
					$blockDataFile = getLocaleFileName( $SITE_LOCATION . '/content/block_content/' . $blockName . '/' . $blockName, $site['DEFAULT_LOCALE'], '.txt');
				 	if( !file_exists( $blockDataFile) ) {
						//block data file does not exist
				 	} else {
				 		$blockJSONData = file_get_contents( $blockDataFile);
				 		$blockViewData = json_decode( cleanJSONString( $blockJSONData), true);
				 		//$viewData = array_merge( $viewData, $blockViewData);	//previous values will be overwritten by block values - cascade
					  	$smarty->assign( 'block_' . $blockName, $blockViewData);
				 	}
				}
			}
			
			if( isset( $cdef['blocks']) && !empty( $cdef['blocks']) ) {
				foreach( $cdef['blocks'] as $blockName) {
					$blockDataFile = getLocaleFileName( $SITE_LOCATION . '/content/block_content/' . $blockName . '/' . $blockName, $site['DEFAULT_LOCALE'], '.txt');
				 	if( !file_exists( $blockDataFile) ) {
						//block data file does not exist
				 	} else {
				 		$blockJSONData = file_get_contents( $blockDataFile);
				 		$blockViewData = json_decode( cleanJSONString( $blockJSONData), true);
				 		//$viewData = array_merge( $viewData, $blockViewData);	//previous values will be overwritten by block values - cascade
					  	$smarty->assign( 'block_' . $blockName, $blockViewData);
				 	}
				}
			}

		  	$smarty->assign('data', $viewData);

			
			//======= LOAD BLOCK DESIGN ======
			$blocks = array();
			
			if( isset( $site['GLOBAL_BLOCKS'] ) && !empty( $site['GLOBAL_BLOCKS'] ) ) {
				foreach( $site['GLOBAL_BLOCKS'] as $blockName) {
					$blockFile = getLocaleFileName( $SITE_LOCATION . '/design/blocks/' . $blockName . '/' . $blockName, $site['DEFAULT_LOCALE'], '.tpl');
					$blocks[ $blockName] = $blockFile;
				}
			}
			
			if( isset( $cdef['blocks']) && !empty( $cdef['blocks']) ) {
				foreach( $cdef['blocks'] as $blockName) {
					$blockFile = getLocaleFileName( $SITE_LOCATION . '/design/blocks/' . $blockName . '/' . $blockName, $site['DEFAULT_LOCALE'], '.tpl');
					$blocks[ $blockName] = $blockFile;
				}
			}
			
		  	$smarty->assign('blocks', $blocks);
			//===============================


			//======= LOAD TEMPLATE ======
			$templateName = $site['DEFAULT_TEMPLATE'];
			if( isset( $cdef['template']) && !empty( $cdef['template']) ) {
				$templateName = $cdef['template'];
			}
			$templateFile = getLocaleFileName( $SITE_LOCATION . '/design/templates/' . $templateName . '/' . $templateName, $site['DEFAULT_LOCALE'], '.tpl');

			//======= OUTPUT PAGE ======
			$smarty->display( $templateFile);
		}
		
	}
	

	//strips characters that break parsing ( \t\n\r)
	function cleanJSONString( $jsonString) {
		$illegalChars = array("\t", "\n", "\r");
		$cleanJSON = str_replace( $illegalChars, "", $jsonString);
		return $cleanJSON;
	}

	//starts by looking for the global and works towards to most localized
	//returns an array of paths
	//perfect for resources like css and javascript
	function getAllLocaleFileNames( $fileNamePrefix, $localeString, $fileNameSuffix) {
		/*
			start:
			
			foo.css
			foo_en.css
			foo_en-GB.css
			foo_en-GB-london.css
		*/

		$paths = array();

		//first check for a global locale:
		$testFilename = $fileNamePrefix . $fileNameSuffix;
		//echo $testFilename;
	 	if( file_exists( $testFilename) ) {
	 		//great, found a global file:
	 		array_push( $paths, $testFilename);
	 	}


		if( empty( $localeString) ) {
			//locale string part is empty, no point continuing:
			return $paths;
		}

		if( false === stripos( $localeString, '-') ) {
			//we only have a single locale part:
			$testFilename = $fileNamePrefix . '_' . $localeString . $fileNameSuffix;
			//echo '<br>SINGLE: ' . $testFilename . '<br>';
		 	if( file_exists( $testFilename) ) {
		 		//great, found a global file:
		 		array_push( $paths, $testFilename);
		 	}

			return $paths;
		}
		
		$localStringPaths = explode( '-', $localeString);
		//var_dump( $localStringPaths);
		$accumulator = $localStringPaths[0];

		for ( $i = 1, $max = sizeof( $localStringPaths); $i <= $max; $i++) {

			$testFilename = $fileNamePrefix . '_' . $accumulator . $fileNameSuffix;
			//echo '<br>' . $testFilename . '<br>';
		 	if( file_exists( $testFilename) ) {
		 		//great, found a global file:
		 		array_push( $paths, $testFilename);
		 	}

			$accumulator = $accumulator . '-' . $localStringPaths[ $i];
			//echo '<br>' . $accumulator . '<br>';
		}

		return $paths;		
	}
	
	//returns the name of a file, looks for more and more general 'locales' until file is found.
	//returns false if no suitable file is found
	//locale strings are case-insensitive: "en-US" is the same as "en-us"
	function getLocaleFileName( $fileNamePrefix, $localeString, $fileNameSuffix) {
		
		/*
			"en_GB_london"
			"en_GB"
			"en"
			""
		*/
		
		$testFilename = $fileNamePrefix . '_' . $localeString . $fileNameSuffix;
		//echo 'START: '. $localeString . '<br>';
		
	 	if( !file_exists( $testFilename) ) {
			//file does not exist, search for locale ancestors:

			$testLocalString = $localeString;
			$keepGoing = true;
			
			//	"en_gb_london"
			while( $keepGoing) {
				$positionOfLastUnderscore = strripos( $testLocalString, '-');
				//echo $positionOfLastUnderscore . '<br>';
						
				if( false === $positionOfLastUnderscore) {
					//there is no underscore - we have no more parts:
					// "en"
					$keepGoing = false;
				} else {
					
					$testLocalString = substr( $testLocalString, 0, $positionOfLastUnderscore);
					//echo $testLocalString . '<br>';
				}

				$testFilename = $fileNamePrefix . '_' . $testLocalString . $fileNameSuffix;
				//echo $testFilename . '<br>';
			 	if( file_exists( $testFilename) ) {
			 		//great, found a suitable file:
			 		return $testFilename;
			 	}
			}

			//now check for a 'global' locale "foo.txt":
			$testFilename = $fileNamePrefix . $fileNameSuffix;
		 	if( file_exists( $testFilename) ) {
		 		//great, found a globally (unlocalized) file:
		 		return $testFilename;
		 	}
			
	 	} else {
	 		return $testFilename;
	 	}
	}
 
 
 	//loads block data and block view
 	function loadBlock( $blockName) {
 		
 	}	 
?>